#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Nov 10 22:36:41 2021

@author: li
"""
import torch
import torch.nn as nn
import train
import numpy as np

train_image_path = './shape/train'
val_image_path = './shape/val'
label = np.load('./shape/label.npy',allow_pickle=True).item()
batch_size = 20
EPOCHS = 160
SAVE_NAME = './1'

# 1. define network ==================================================================


class NET(nn.Module):  
    def __init__(self, num_classes):
        super(NET, self).__init__()
        #define layers
            
            
            
            
            
            
            
        self._initialize_weights()

    def forward(self,x):
        # define forward action
        
        
        
        return x
    
    def _initialize_weights(self):
        for m in self.modules():
            if isinstance(m, nn.Conv2d):
                nn.init.kaiming_normal_(m.weight, mode='fan_out', nonlinearity='relu')
                if m.bias is not None:
                    nn.init.constant_(m.bias, 0)
            elif isinstance(m, nn.BatchNorm2d):
                nn.init.constant_(m.weight, 1)
                nn.init.constant_(m.bias, 0)
            elif isinstance(m, nn.Linear):
                nn.init.normal_(m.weight, 0, 0.01)
                nn.init.constant_(m.bias, 0)

if __name__ == '__main__':
    
    net = NET(num_classes = 3)
    # net = torchvision.models.mobilenet_v2(num_classes=3)
    
    # 2. define dataloader ==================================================================
    
    train_loader,val_loader,_ = train.local_dataset(
                                                train_path = train_image_path, 
                                                val_path = val_image_path,
                                                batch_size = batch_size,
                                                labellist = label
                                                  )
    
    
    # 3. define loss and optimizer ===========================================================
    
    criterion = nn.CrossEntropyLoss()
    optimizer = torch.optim.SGD(      
        net.parameters(),  
        lr=0.01,
        momentum=0.9,
        weight_decay=1e-3,
        nesterov=True,
    )
    
    # 4. start to train ======================================================================
    
    device = torch.device("cpu")
    print("            =======  Training  ======= \n") 
    train.train_stepLR(net, EPOCHS, train_loader, val_loader, device, criterion, optimizer, SAVE_NAME)
    print("\n            =======  Training Finished  ======= \n")
    
    # b = net(torch.FloatTensor([1,1,0,1])).argmax(dim=0)