#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Nov 16 15:47:53 2021

@author: ihpc
"""

import torch
import numpy as np
from conv import NET
import torchvision.transforms as transforms
from PIL import Image

def show(img_path,net,label):
    
    transform=transforms.Compose(
        [
            transforms.ToTensor(),
            transforms.Normalize(
                (0.4914, 0.4822, 0.4465), (0.2023, 0.1994, 0.2010)
            ),
        ]
    )
    
    img = Image.open(img_path).convert('RGB')
    img.show()
    img = transform(img).unsqueeze(0)
    net.eval()
    output = net(img)
    print(output)
    output = output.argmax(dim=1).item()
    for key in label:
        if label[key] == output:
            return key
    return False

img_path = './shape/test/c01.png'

net = NET(num_classes = 3)
parameter = torch.load('./1'+'.pth',map_location=torch.device('cpu'))
net.load_state_dict(parameter)

label = np.load('./shape/label.npy',allow_pickle=True).item()
print(show(img_path,net,label))